#include "ConnexionWOL.h"

#define INITGUID
#include <initguid.h> 
#include <Connmgr.h> //to ask wm a connexion

sockaddr ConnexionWOL::myIPDevice;

ConnexionWOL::ConnexionWOL(HINSTANCE hInstance,bool backTransparent):EventHandler(hInstance,L"Wake on Wan",backTransparent)
{
	saveValues=true;
	this->backTransparent=backTransparent;
	threadID=NULL;
}

ConnexionWOL::~ConnexionWOL(void)
{
	if(threadID!=NULL)
		TerminateThread(threadID,0);//if thread running, close it !
}


void ConnexionWOL::initApplication(){
	////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////

	int wMax=GlobalInformations::rs.right;
	int hMax=GlobalInformations::rs.bottom;

	Section *sec=new Section(100,0,0,wMax,L"Wake on wan");

	MyPanel* panelTmp;

	panelTmp=new MyPanel(-1,0,0,wMax,L"Host information :",true,false);
	MyLabel* lab=new MyLabel(-1,10,15,L"Host IP or name :",TEXT_NORMAL);
	if(backTransparent){
		lab->changeColor(0xEEEEEE);
		lab->changeColor(RGB16(2,4,2),false);
	}
	panelTmp->add(lab);
	panelTmp->add(new MyEditControl(1,30,0,wMax-60));
	lab=new MyLabel(-1,10,10,L"Mac address :",TEXT_NORMAL);
	if(backTransparent){
		lab->changeColor(0xEEEEEE);
		lab->changeColor(RGB16(2,4,2),false);
	}
	panelTmp->add(lab);
	panelTmp->add(new MyEditControl(2,30,0,wMax-60));
	lab=new MyLabel(-1,10,5,L"Port :",TEXT_NORMAL);
	if(backTransparent){
		lab->changeColor(0xEEEEEE);
		lab->changeColor(RGB16(2,4,2),false);
	}
	panelTmp->add(lab);
	panelTmp->add(new MyEditControl(3,30,0,wMax-60));
	sec->add(panelTmp);


	sec->add(new MyItem(4,10,30,ITEM_IS_BUTTON_NORMAL,ITEM_STATE_DSBL_EMPTY,L"Send magic packet !"));

	lab=new MyLabel(6,10,30,L"Trying to connect...\n\n",TEXT_NORMAL);
	if(backTransparent){
		lab->changeColor(0xEEEEEE);
		lab->changeColor(RGB16(2,4,2),false);
	}
	sec->add(lab);

	MyItem* bQuit=new MyItem(5,0,50,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"Quit");
	bQuit->centerH();
	sec->add(bQuit);

	GlobalInformations::window->add(sec);

	////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////
	//now use register to know what should we do :

	bool *showInfo=new bool;
	*showInfo=true;
	HKEY myKey;
	infoWOL infos;
	infos.adIP[0]=L'\0';
	infos.adMAC[0]=L'\0';
	infos.port[0]=L'\0';
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\WakeOnWAN", 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, 0)==ERROR_SUCCESS){
			DWORD sizeValue=sizeof(bool);
			RegQueryValueEx(myKey,L"showInfo", 0, 0, (BYTE*)showInfo, &sizeValue);//get the info...

			threadID=CreateThread(NULL,NULL, ConnexionWOL::connect,showInfo,NULL,NULL);//print the message about data exchange and connect...

			sizeValue=sizeof(infos.adIP);
			RegQueryValueEx(myKey,L"lastIP", 0, 0, (BYTE*)&infos.adIP, &sizeValue);//get the info...
			sizeValue=sizeof(infos.adMAC);
			RegQueryValueEx(myKey,L"lastMAC", 0, 0, (BYTE*)&infos.adMAC, &sizeValue);//get the info...
			sizeValue=sizeof(infos.port);
			RegQueryValueEx(myKey,L"lastPort", 0, 0, (BYTE*)&infos.port, &sizeValue);//get the info...
			RegCloseKey(myKey);
	}

	////////////////////////////////////////////////////////////////////////////////////////////////
	((MyEditControl*)Element::getElementByID(1))->setText(infos.adIP);
	((MyEditControl*)Element::getElementByID(2))->setText(infos.adMAC);
	((MyEditControl*)Element::getElementByID(3))->setText(infos.port);

}

void ConnexionWOL::GetDeviceIP(CONNMGR_CONNECTION_DETAILED_STATUS  *devices){
	if (devices==NULL){
		//search for available connections:
		devices=new CONNMGR_CONNECTION_DETAILED_STATUS;
		HRESULT hResult; 
		DWORD nbOctet=sizeof(CONNMGR_CONNECTION_DETAILED_STATUS);//first set to 2 (we don't know how many conn we have...)

		hResult=ConnMgrQueryDetailedStatus(devices,&nbOctet);
		while(hResult==HRESULT_FROM_WIN32(ERROR_INSUFFICIENT_BUFFER)){
			//now nbOctet contain the number of conn...
			delete []devices;
			devices=(CONNMGR_CONNECTION_DETAILED_STATUS  *)malloc(nbOctet);

			hResult=ConnMgrQueryDetailedStatus(devices,&nbOctet);
		}
		if(hResult!=S_OK){
			((MyLabel*)Element::getElementByID(6))->setText(L"Can't retrieve available connections...");
			return;
		}
	}
	//search for the internet connection :
	CONNMGR_CONNECTION_DETAILED_STATUS  *connTmp=devices;
	bool hasIP=false;
	while(connTmp!=NULL){
		if(connTmp->pIPAddr!=NULL&&connTmp->pIPAddr->cIPAddr>0&&connTmp->dwConnectionStatus&CONNMGR_STATUS_CONNECTED){
			myIPDevice=*((sockaddr*)connTmp->pIPAddr->IPAddr);
			SOCKADDR_IN *IP_FromDevice=(SOCKADDR_IN *)&myIPDevice;

			WCHAR szIpAddress[256];
			wsprintf(szIpAddress,L"Ready to send the magic packet !\nDevice's IP: %d.%d.%d.%d",IP_FromDevice->sin_addr.S_un.S_un_b.s_b1,
				IP_FromDevice->sin_addr.S_un.S_un_b.s_b2, IP_FromDevice->sin_addr.S_un.S_un_b.s_b3,
				IP_FromDevice->sin_addr.S_un.S_un_b.s_b4);
			hasIP=true;
			wstring AdIP_str=szIpAddress;
			((MyLabel*)Element::getElementByID(6))->setText(AdIP_str);
		}
		connTmp=connTmp->pNext;
	}
	if(!hasIP)
		((MyLabel*)Element::getElementByID(6))->setText(L"Can't find your IP address...");
	delete []devices;
}
DWORD WINAPI ConnexionWOL::connect(LPVOID askPtr){
	bool *ask=((bool*)askPtr);

	//Need a data connection :
	if(*ask){
		int rep=MessageBoxSense::show(L"Warning !",L"OK for a data connection ?\n(be careful not exceed the plan limit)",MESSAGE_YESNO);
		if(rep==MSG_REP_NO){
			PostMessage(GlobalInformations::m_hWnd,WM_CLOSE,NULL,NULL);//WM_CLOSE
			return 0;
		}
	}
	delete ask;

	HKEY myKey;
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\WakeOnWAN", 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, 0)==ERROR_SUCCESS){
			DWORD sizeValue=sizeof(bool);
			bool newVal=false;
			RegSetValueEx(myKey, L"showInfo", 0, REG_BINARY, (BYTE*)&newVal, sizeValue);//set the new info
			RegCloseKey(myKey);
	}

	//search for available connections:
	CONNMGR_CONNECTION_DETAILED_STATUS  *connMgrDet=new CONNMGR_CONNECTION_DETAILED_STATUS[2];
	HRESULT hResult; 
	DWORD nbOctet=sizeof(CONNMGR_CONNECTION_DETAILED_STATUS)*2;//first set to 2 (we don't know how many conn we have...)

	hResult=ConnMgrQueryDetailedStatus(connMgrDet,&nbOctet);
	while(hResult==HRESULT_FROM_WIN32(ERROR_INSUFFICIENT_BUFFER)){
		//now nbOctet contain the number of conn...
		delete []connMgrDet;
		connMgrDet=(CONNMGR_CONNECTION_DETAILED_STATUS  *)malloc(nbOctet);

		hResult=ConnMgrQueryDetailedStatus(connMgrDet,&nbOctet);
	}
	if(hResult!=S_OK){
		((MyLabel*)Element::getElementByID(6))->setText(L"Can't retrieve available connections...");
		return 0;
	}
	//search for the internet connection :
	CONNMGR_CONNECTION_DETAILED_STATUS  *connTmp=connMgrDet;
	CONNMGR_CONNECTION_DETAILED_STATUS  *connDestNet=NULL;
	while(connTmp!=NULL){
		if(connTmp->guidDestNet==IID_DestNetInternet)
			if (connTmp->dwConnectionStatus&CONNMGR_STATUS_CONNECTED)
			{
				((MyLabel*)Element::getElementByID(6))->setText(L"Ready to send magic packet !");
				((MyItem*)Element::getElementByID(4))->switchVisibility();
				GetDeviceIP(connMgrDet);
				//already connected...
				return 0;
			}else
				connDestNet=connTmp;
		connTmp=connTmp->pNext;
	}
	//if we are here, the connection we have to use is connDestNet :
	if(connDestNet==NULL){
		((MyLabel*)Element::getElementByID(6))->setText(L"Can't find web connections...");
		return 0;
	}
	bool connect=connDestNet->pIPAddr!=NULL&&connDestNet->pIPAddr->cIPAddr>0;
	delete []connMgrDet;
	if(!connect){
		CONNMGR_CONNECTIONINFO connInfo;
		ZeroMemory(&connInfo, sizeof(connInfo));
		connInfo.cbSize = sizeof(connInfo);
		connInfo.bDisabled = FALSE;
		connInfo.dwPriority = CONNMGR_PRIORITY_USERINTERACTIVE;
		connInfo.dwParams = CONNMGR_PARAM_GUIDDESTNET;
		connInfo.guidDestNet = IID_DestNetInternet;
		HANDLE connexion;
		DWORD pdwStatus;
		((MyLabel*)Element::getElementByID(6))->setText(L"Try to connect...");
		hResult = ConnMgrEstablishConnectionSync(&connInfo, &connexion, 30 * 1000,&pdwStatus);
		if(hResult!=S_OK){
			((MyLabel*)Element::getElementByID(6))->setText(L"Can't establish connection to web...");
			return 0;
		}
	}
	//we are connected now...
	((MyLabel*)Element::getElementByID(6))->setText(L"Ready to send magic packet");
	((MyItem*)Element::getElementByID(4))->switchVisibility();
	GetDeviceIP(NULL);
	
	return 0;

}
unsigned char ConnexionWOL::hexaToBin(char* number){
	unsigned char outNb=0;
	char c = *number;

	if (isdigit(c))
		outNb = c - '0';
	else if (c >= 'a' && c <= 'f')
		outNb = c - 'a' + 10;
	else if (c >= 'A' && c <= 'F')
		outNb = c - 'A' + 10;
	else
		return 0xFF;

	outNb <<= 4;//that was the 4 first bytes...
	c = *(number+1);
	if (isdigit(c))
		outNb |= c - '0';
	else if (c >= 'a' && c <= 'f')
		outNb |= c - 'a' + 10;
	else if (c >= 'A' && c <= 'F')
		outNb |= c - 'A' + 10;
	else
		return 0xFF;

	return outNb;
};

void ConnexionWOL::messageTreatment(Element* src,int idEvent){
	if(idEvent!=EVENT_CLICK)
		return;//don't want other event...
	switch(src->getId()){
		case 4://Button
			{
				SetCursor(LoadCursor(NULL, IDC_WAIT));

				char chszUserEntry[255];
				// convert the unicode input to ascii for lookup functions
				wcstombs(chszUserEntry, ((MyEditControl*)Element::getElementByID(1))->getText().c_str(), 255);

				//first get the port number
				char portNb[4];
				// convert the unicode input to ascii
				wcstombs(portNb, ((MyEditControl*)Element::getElementByID(3))->getText().c_str(), 4);

				// convert the dotted IP to a byte order IP
				IPAddr ipAdress = inet_addr((const char*)chszUserEntry);

				if(INADDR_NONE == ipAdress)
				{
					//maybe it's an host name :
					addrinfo *addrinf;
					if(0!=getaddrinfo((const char*)chszUserEntry,(const char*)portNb,NULL,&addrinf)){
						((MyLabel*)Element::getElementByID(6))->setText(L"Host not found...");
						SetCursor(NULL);
						Element::redraw();
						return;
					}
					//use the first IP found :
					ipAdress = ((sockaddr_in*)addrinf->ai_addr)->sin_addr.s_addr;
					freeaddrinfo(addrinf);
				}
				//if we are here, we have a correct address !
				//compute the trame :
				unsigned char trame[255];

				//first get the mac address
				char hexaMacAddr[255];
				// convert the unicode input to ascii
				wcstombs(hexaMacAddr, ((MyEditControl*)Element::getElementByID(2))->getText().c_str(), 255);
				string hexa=hexaMacAddr;

				size_t pos=0;
				pos=hexa.find(':',pos);//delete characters ':'
				while(pos!=string::npos){
					hexa.erase(pos,1);
					pos=hexa.find(':',pos+1);
				}
				pos=0;
				pos=hexa.find('-',pos);//delete characters '-'
				while(pos!=string::npos){
					hexa.erase(pos,1);
					pos=hexa.find('-',pos+1);
				}
				const char *hexatmp=hexa.c_str();
				char macAddr[6];
				for(int j=0;j<6;j++){
					macAddr[j]=this->hexaToBin(&hexa[j*2]);
				}
				unsigned char test=0x24;
				unsigned char test1=0x21;
				unsigned char test2=0xE4;


				trame[0]=0xFF;
				trame[1]=0xFF;
				trame[2]=0xFF;
				trame[3]=0xFF;
				trame[4]=0xFF;
				trame[5]=0xFF;

				unsigned char *ptr=&trame[6];
				for(int i=0;i<16;i++){
					for(int j=0;j<6;j++){
						*ptr++=macAddr[j];
					}
				}
				SOCKET mySoc;

				/* setup the packet socket */
				if ((mySoc = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
					LocalisedString::explainFail(L"Can't create socket...",L"Socket creation error");


				//----------------------
				// Bind the socket.
				if (bind( mySoc, 
					(SOCKADDR*) &ConnexionWOL::myIPDevice, 
					sizeof(ConnexionWOL::myIPDevice)) == SOCKET_ERROR) {
						LocalisedString::explainFailWinAPI(L"bind socket");
						closesocket(mySoc);
						return;
				}


				/* Set up address */
				struct sockaddr_in sap;
				sap.sin_family = AF_INET;
				sap.sin_addr.s_addr = ipAdress;
				sap.sin_port = htons(atoi(portNb));

				if(sap.sin_addr.S_un.S_un_b.s_b1==0x0A){//10.X.X.X -> should be 10.255.255.255
					sap.sin_addr.S_un.S_un_b.s_b2=0xFF;
					sap.sin_addr.S_un.S_un_b.s_b3=0xFF;
					sap.sin_addr.S_un.S_un_b.s_b4=0xFF;
				}
				if(sap.sin_addr.S_un.S_un_b.s_b1==0xAC&&
					sap.sin_addr.S_un.S_un_b.s_b2>=0x10&&
					sap.sin_addr.S_un.S_un_b.s_b2<0x20){//between 172.16.0.1 & 172.31.255.254-> should be 172.X.255.255
						sap.sin_addr.S_un.S_un_b.s_b3=0xFF;
						sap.sin_addr.S_un.S_un_b.s_b4=0xFF;
				}
				if(sap.sin_addr.S_un.S_un_b.s_b1==0xC0&&
					sap.sin_addr.S_un.S_un_b.s_b2==0x10&&
					sap.sin_addr.S_un.S_un_b.s_b3==0xA8){//between 172.16.0.1 & 172.31.255.254-> should be 172.X.X.255
						sap.sin_addr.S_un.S_un_b.s_b4=0xFF;
				}


				//we are now ready to send a message...

				/* Send the packet out */
				if (sendto (mySoc, (char*)trame, 102, 0, (struct sockaddr *)&sap, sizeof (sap)) < 0)
					LocalisedString::explainFail(L"Can't send magic packet...",L"sendto error");
				closesocket(mySoc);
				

				WCHAR szIpAddress[256];
				wsprintf(szIpAddress,L"Magic packet sended to %d.%d.%d.%d ;-)\nIf you're in the computer's network, use a broadcast address!",sap.sin_addr.S_un.S_un_b.s_b1,
					sap.sin_addr.S_un.S_un_b.s_b2, sap.sin_addr.S_un.S_un_b.s_b3,
					sap.sin_addr.S_un.S_un_b.s_b4);
				((MyLabel*)Element::getElementByID(6))->setText(szIpAddress);
				SetCursor(NULL);
				Element::redraw();

				break;
			}
		case 5://Button quit
			{
				((MyLabel*)Element::getElementByID(6))->setText(L"Goodbye !!!");
				//save the info in registry :
				HKEY myKey;
				if(saveValues){
					if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\WakeOnWAN", 0, 0, REG_OPTION_NON_VOLATILE,
						KEY_ALL_ACCESS, 0, &myKey, 0)==ERROR_SUCCESS){
							wstring val=((MyEditControl*)Element::getElementByID(1))->getText();
							DWORD sizeValue=val.length()*sizeof(val[0]);//a WCHAR take usually 2 bytes...
							RegSetValueEx(myKey, L"lastIP", 0, REG_SZ, (const BYTE*)val.c_str(), sizeValue);//set the new info

							val=((MyEditControl*)Element::getElementByID(2))->getText();
							sizeValue=val.length()*sizeof(val[0]);
							RegSetValueEx(myKey, L"lastMAC", 0, REG_SZ, (const BYTE*)val.c_str(), sizeValue);//set the new info

							val=((MyEditControl*)Element::getElementByID(3))->getText();
							sizeValue=val.length()*sizeof(val[0]);
							RegSetValueEx(myKey, L"lastPort", 0, REG_SZ, (const BYTE*)val.c_str(), sizeValue);//set the new info
							RegCloseKey(myKey);
					}
				}
				PostMessage(GlobalInformations::m_hWnd,WM_CLOSE,NULL,NULL);//WM_CLOSE
			}
		default:
			;
	}
};

